### Virtual Method

# Camel Sasl challenge_sync

#### Declaration [src]

    GByteArray*
    challenge_sync (
      CamelSasl* sasl,
      GByteArray* token,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

If `token` is `NULL`, generate the initial SASL message to send to the server. (This will be `NULL` if the client doesn’t initiate the exchange.) Otherwise, `token` is a challenge from the server, and the return value is the response.

Free the returned `GByteArray` with g_byte_array_free().

#### Parameters

`token`

  Type: An array of `guint8`

  A token, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guint8`

The SASL response or `NULL`. If an error occurred, `error` will also be set.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.